//Add CR Assign to Analyst By Group
app.custom.formTasks.add('ChangeRequest', "CR Assign Analyst By Group", function (formObj, viewModel) {	

  crAssignAnalystByGroup();
  
});
//Add CR Assign to Analyst By Group
function crAssignAnalystByGroup () {
	//Replace Support Group Extension Name below
	//Get-SCSMEnumeration -Name ChangeRequestSupportGroup | Format-Table Name, Id
	//Copy Id to CRSupportGroupEnumGuid below	
	var CRSupportGroupEnumGuid = "033102c1-7fee-2da1-b705-1bf4a8763473";
	
	$.ajax({
		url: "/api/V3/Enum/GetList",
		data: {Id: CRSupportGroupEnumGuid},
		type: "GET",
		success: function (data) {
			//Call the function to build, populate groups, and open the Assign Analyst By Group Window
			loadCRSupportGroups(data);
			//After the Assign Analyst By Group Window has opened, determine if there is already a Support Group or User assigned and auto select them
				//Wait a short period of time to make sure the windows has fully loaded
				_.delay(function () {
					var crsgid = pageForm.viewModel.SupportGroup.Id;
					//If there is already a Support Group selected then Auto Select it
					if (crsgid != null) {
						var ddl = $("#sgselected").data("kendoDropDownList");
						ddl.select(function(dataItem) {
							return dataItem.Id === crsgid;
						});
						//Load only Users within the Auto Selected Support Group
						$.ajax({
							url: "/api/V3/User/GetSupportGroupUsers",
							data: {id: crsgid},
							type: "GET",
							cache: false,
							success: function (data2) {
								$("#userselected").kendoDropDownList({
									optionLabel: "Select One...",
									dataTextField: "Name",
									dataValueField: "Id",
									dataSource: data2
								});
							}
						});
						//Wait a short period of time show we can check if a Support Group was Auto Selected above
						_.delay(function () {
							var uid = pageForm.viewModel.AssignedWorkItem.BaseId
							//If there is already an Assigned USer then Auto Select it
							if (uid != null) {
								var ddl2 = $("#userselected").data("kendoDropDownList");
								ddl2.select(function(dataItem2) {
									return dataItem2.Id === uid;
								});
							}
						}, 500);										
					}
				}, 1000);
		}
	});
}
//FORTIS
//Add CR Assign to Analyst By Group
function loadCRSupportGroups (data){
	//use requirejs to load the HTML template first
	require(["text!/CustomSpace/customtasks.crassign.html"], function (template) {
		//make a jQuery obj
		cont = $(template);

		//create a view model to handle the UX
		//if there are no activities currently then disable the drop-down menu

		var _vmWindow = new kendo.observable({
			sgdropDownData: data,
			valueChanged : function(e) {
				var dataItem = e.sender.dataItem();
				console.log (dataItem.Id)
					$.ajax({
						url: "/api/V3/User/GetSupportGroupUsers",
						data: {id: dataItem.Id},
						type: "GET",
						cache: false,
						success: function (data2) {
							console.log (data2)
							$("#userselected").kendoDropDownList({
								optionLabel: "Select One...",
								dataTextField: "Name",
								dataValueField: "Id",
								dataSource: data2
							});
						}
					});
			},
			okClick: function () {
				var userid = $("#userselected option:selected").val();
				if (userid == ""){
					pageForm.viewModel.AssignedWorkItem.set("BaseId", null);
					pageForm.viewModel.AssignedWorkItem.set("DisplayName", null);
				}
				var sgid = $("#sgselected option:selected").val();
				var userdisplay = $("#userselected option:selected").text();
				var sgdisplay = $("#sgselected option:selected").text();
				pageForm.viewModel.AssignedWorkItem.set("BaseId", userid);
                pageForm.viewModel.AssignedWorkItem.set("DisplayName", userdisplay);
				pageForm.viewModel.SupportGroup.set("Id", sgid);
                pageForm.viewModel.SupportGroup.set("Name", sgdisplay);
				//Change below data-role equal to the Name of the Extended Change Request Support Group
				var cbx = $("div[data-role='SupportGroup'] span span input").val(""+ sgdisplay +"");
				customWindow.close();
				customWindow.destroy();
			},
			cancelClick: function () {
				customWindow.close();
				customWindow.destroy();
			}
		});	
		//create the kendo window
		customWindow = cont.kendoWindow({
			title: "Assign To Analyst By Group",
			resizable: false,
			modal: true,
			viewable: false,
			width: 500,
			height: 400,
			close: function () {
	 
			},
			activate: function () {
				//on window activate bind the view model to the loaded template content
				kendo.bind(cont, _vmWindow);
			}
		}).data("kendoWindow");
	 
		//now open the window
		customWindow.open().center();
	});
}
	